<template>
  <div
    :style="style"
    class="range-container"
  >
    <div class="mr-2">
      {{ min }}
    </div>
    <vue-slider
      ref="slider"
      :disabled="disabled"
      :dot-options="dotOptions"
      :max="max"
      :min="min"
      :process-style="{ backgroundColor: '#5f566a' }"
      :tooltip-style="{ backgroundColor: '#5f566a', borderColor: '#5f566a' }"
      :value="value"
      contained="true"
      tooltip-placement="bottom"
      @change="$emit('input', $event)"
    />
    <div class="ml-2">
      {{ max }}
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import VueSlider from 'vue-slider-component';

import 'vue-slider-component/theme/default.css';

interface VueSliderDotOption {
  tooltip: string;
}

export default Vue.extend({
  components: {
    VueSlider,
  },

  props: {
    disabled: {
      type: Boolean,
      default: false,
      required: false,
    },
    max: {
      type: Number,
      required: true,
    },
    min: {
      type: Number,
      required: true,
    },
    value: {
      type: Array,
      required: true,
    },
  },

  computed: {
    dotOptions(): VueSliderDotOption[] {
      return [
        {
          tooltip: this.value[0] === this.min ? 'never' : 'always',
        },
        {
          tooltip: this.value[1] === this.max ? 'never' : 'always',
        },
      ];
    },
    style() {
      if (this.dotOptions.some((option) => option.tooltip === 'always')) {
        return 'margin-bottom: 1.5em;';
      }
      return '';
    },
  },

  methods: {
    setMax(val: number) {
      (<any> this.$refs.slider).setValue([this.min, val]);
    },
    setMin(val: number) {
      (<any> this.$refs.slider).setValue([val, this.max]);
    },
    set(min: number, max: number) {
      (<any> this.$refs.slider).setValue([min, max]);
    },
  },
});
</script>

<style scoped>
.range-container {
  display: flex;
  align-items: center;
}

.vue-slider {
  flex: 1;
}
</style>
